=== debian/changelog ===
wabt (1.0.6-1) unstable; urgency=medium

  * Initial release. (Closes: #916611)

 -- Markus Koschany <apo@debian.org>  Mon, 17 Dec 2018 22:18:24 +0100
