=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/privacybadger-$1\.tar\.gz/ \
  https://github.com/WebAssembly/wabt/tags .*/v?(\d\S+)\.tar\.gz
