=== debian/changelog ===
wabt (1.0.8-1) unstable; urgency=medium

  * New upstream version 1.0.8.
  * Update d/copyright for new release and remove the demo because it contains
    Javascript files without source and we cannot rebuild libwabt.js without
    Emscripten. The demo is not needed too.
  * Declare compliance with Debian Policy 4.3.0.
  * Switch to compat level 12.

 -- Markus Koschany <apo@debian.org>  Fri, 18 Jan 2019 14:30:00 +0100
