=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Markus Koschany <apo@debian.org>
 Build-Depends:
  cmake,
- debhelper (>= 11),
+ debhelper (>= 12),
  python,
  re2c
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://github.com/WebAssembly/wabt
 Vcs-Git: https://salsa.debian.org/debian/wabt.git
 Vcs-Browser: https://salsa.debian.org/debian/wabt
