## wabt 1.0.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,7 +19,6 @@
 
 option(BUILD_TESTS "Build GTest-based tests" ON)
 option(BUILD_TOOLS "Build wabt commandline tools" ON)
-option(RUN_RE2C "Run re2c" ON)
 option(USE_ASAN "Use address sanitizer" OFF)
 option(USE_MSAN "Use memory sanitizer" OFF)
 option(USE_LSAN "Use leak sanitizer" OFF)
@@ -155,7 +154,7 @@
           message(WARNING "Unknown target architecture!")
         endif ()
       else ()
-        message(WARNING "Error running file on dummy executable")
+        message(WARNING "Error running `file` command on dummy executable")
       endif ()
     else ()
       message(WARNING "Error compiling dummy.c file")
@@ -203,21 +202,6 @@
 endif ()
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${WABT_SOURCE_DIR}/cmake)
-find_package(RE2C)
-if (RUN_RE2C AND RE2C_EXECUTABLE AND (NOT ${RE2C_VERSION} VERSION_LESS "0.16"))
-  message(STATUS "Using generated re2c lexer")
-  set(WAST_LEXER_CC ${WABT_SOURCE_DIR}/src/wast-lexer.cc)
-  set(WAST_LEXER_GEN_CC ${WABT_BINARY_DIR}/wast-lexer-gen.cc)
-  RE2C_TARGET(
-    NAME WAST_LEXER_GEN_CC
-    INPUT ${WAST_LEXER_CC}
-    OUTPUT ${WAST_LEXER_GEN_CC}
-    OPTIONS -bc8 -W -Werror
-  )
-else ()
-  message(STATUS "Using prebuilt re2c lexer")
-  set(WAST_LEXER_GEN_CC src/prebuilt/wast-lexer-gen.cc)
-endif ()
 
 add_custom_target(everything)
 
@@ -255,9 +239,9 @@
   src/type-checker.cc
   src/utf8.cc
   src/validator.cc
+  src/wast-lexer.cc
   src/wast-parser.cc
   src/wat-writer.cc
-  ${WAST_LEXER_GEN_CC}
 
   # TODO(binji): Move this into its own library?
   src/interp/binary-reader-interp.cc
@@ -420,3 +404,23 @@
       src/test-binary-reader.cc
       src/test-circular-array.cc
       src/test-interp.cc
+      src/test-intrusive-list.cc
+      src/test-literal.cc
+      src/test-string-view.cc
+      src/test-filenames.cc
+      src/test-utf8.cc
+      src/test-wast-parser.cc
+      third_party/gtest/googletest/src/gtest_main.cc
+    )
+    wabt_executable(
+      NAME wabt-unittests
+      SOURCES ${UNITTESTS_SRCS}
+      LIBS libgtest ${CMAKE_THREAD_LIBS_INIT}
+    )
+
+    if (NOT CMAKE_VERSION VERSION_LESS "3.2")
+      set(USES_TERMINAL USES_TERMINAL)
+    endif ()
+
+    # test running
+    find_package(PythonInterp 2.7 REQUIRED)
