=== debian/changelog ===
wabt (1.0.11-1) unstable; urgency=medium

  * New upstream version 1.0.11.
  * Declare compliance with Debian Policy 4.4.0.
  * Switch to debhelper-compat = 12.
  * Install the complete wasm2c directory as examples to ease further
    development. (Closes: #932007)

 -- Markus Koschany <apo@debian.org>  Sun, 14 Jul 2019 21:50:11 +0200
