## wabt 1.0.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,7 @@
 project(WABT)
 
 option(BUILD_TESTS "Build GTest-based tests" ON)
+option(USE_SYSTEM_GTEST "Use system GTest, instead of building" OFF)
 option(BUILD_TOOLS "Build wabt commandline tools" ON)
 option(USE_ASAN "Use address sanitizer" OFF)
 option(USE_MSAN "Use memory sanitizer" OFF)
@@ -26,20 +27,21 @@
 option(CODE_COVERAGE "Build with code coverage enabled" OFF)
 option(WITH_EXCEPTIONS "Build with exceptions enabled" OFF)
 option(WERROR "Build with warnings as errors" OFF)
-
-if (${CMAKE_C_COMPILER_ID} STREQUAL "Clang")
+option(WIP_TOOLS "Build Work-In-Progress functionality" OFF)
+
+if (CMAKE_C_COMPILER_ID MATCHES "Clang")
   set(COMPILER_IS_CLANG 1)
   set(COMPILER_IS_GNU 0)
   set(COMPILER_IS_MSVC 0)
-elseif (${CMAKE_C_COMPILER_ID} STREQUAL "GNU")
+elseif (CMAKE_C_COMPILER_ID STREQUAL "GNU")
   set(COMPILER_IS_CLANG 0)
   set(COMPILER_IS_GNU 1)
   set(COMPILER_IS_MSVC 0)
-elseif (${CMAKE_C_COMPILER_ID} STREQUAL "MSVC")
+elseif (MSVC)
   set(COMPILER_IS_CLANG 0)
   set(COMPILER_IS_GNU 0)
   set(COMPILER_IS_MSVC 1)
-elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Emscripten")
+elseif (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
   set(COMPILER_IS_CLANG 1)
   set(COMPILER_IS_GNU 0)
   set(COMPILER_IS_MSVC 0)
@@ -206,45 +208,88 @@
 add_custom_target(everything)
 
 add_library(wabt STATIC
+  src/apply-names.h
   src/apply-names.cc
+  src/binary.h
   src/binary.cc
+  src/binary-reader.h
   src/binary-reader.cc
+  src/binary-reader-ir.h
   src/binary-reader-ir.cc
+  src/binary-reader-logging.h
   src/binary-reader-logging.cc
+  src/binary-writer.h
   src/binary-writer.cc
+  src/binary-writer-spec.h
   src/binary-writer-spec.cc
+  src/binding-hash.h
   src/binding-hash.cc
+  src/color.h
   src/color.cc
+  src/common.h
   src/common.cc
+  src/config.h
   src/config.cc
+  src/decompiler.h
+  src/decompiler.cc
+  src/error-formatter.h
   src/error-formatter.cc
+  src/expr-visitor.h
   src/expr-visitor.cc
+  src/feature.h
   src/feature.cc
+  src/filenames.h
   src/filenames.cc
+  src/generate-names.h
   src/generate-names.cc
+  src/hash-util.h
   src/hash-util.cc
+  src/ir.h
   src/ir.cc
+  src/ir-util.h
+  src/ir-util.cc
+  src/leb128.h
   src/leb128.cc
+  src/lexer-source.h
   src/lexer-source.cc
+  src/lexer-source-line-finder.h
   src/lexer-source-line-finder.cc
+  src/literal.h
   src/literal.cc
+  src/opcode.h
   src/opcode.cc
+  src/opcode-code-table.h
   src/opcode-code-table.c
+  src/opcode.def
+  src/option-parser.h
   src/option-parser.cc
+  src/resolve-names.h
   src/resolve-names.cc
+  src/stream.h
   src/stream.cc
+  src/string-view.h
   src/string-view.cc
+  src/token.h
   src/token.cc
+  src/tracing.h
   src/tracing.cc
+  src/type-checker.h
   src/type-checker.cc
+  src/utf8.h
   src/utf8.cc
+  src/validator.h
   src/validator.cc
+  src/wast-lexer.h
   src/wast-lexer.cc
+  src/wast-parser.h
   src/wast-parser.cc
+  src/wat-writer.h
   src/wat-writer.cc
 
   # TODO(binji): Move this into its own library?
+  src/interp/binary-reader-interp.h
   src/interp/binary-reader-interp.cc
+  src/interp/interp.h
   src/interp/interp.cc
   src/interp/interp-disassemble.cc
   src/interp/interp-trace.cc
@@ -369,58 +414,23 @@
       SOURCES src/tools/wasm-strip.cc
       INSTALL
     )
+
+    if (WIP_TOOLS)
+      # wasm-decompile
+      wabt_executable(
+        NAME wasm-decompile
+        SOURCES src/tools/wasm-decompile.cc
+        INSTALL
+      )
+    endif()
   endif ()
 
   find_package(Threads)
   if (BUILD_TESTS)
-    if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/third_party/gtest/googletest)
-      message(FATAL_ERROR "Can't find third_party/gtest. Run git submodule update --init, or disable with CMake -DBUILD_TESTS=OFF.")
-    endif ()
-
-    include_directories(
-      third_party/gtest/googletest
-      third_party/gtest/googletest/include
-    )
-
-    # gtest
-    add_library(libgtest STATIC
-      third_party/gtest/googletest/src/gtest-all.cc
-    )
-
-    # hexfloat-test
-    set(HEXFLOAT_TEST_SRCS
-      src/literal.cc
-      src/test-hexfloat.cc
-      third_party/gtest/googletest/src/gtest_main.cc
-    )
-    wabt_executable(
-      NAME hexfloat_test
-      SOURCES ${HEXFLOAT_TEST_SRCS}
-      LIBS libgtest ${CMAKE_THREAD_LIBS_INIT}
-    )
-
-    # wabt-unittests
-    set(UNITTESTS_SRCS
-      src/test-binary-reader.cc
-      src/test-circular-array.cc
-      src/test-interp.cc
-      src/test-intrusive-list.cc
-      src/test-literal.cc
-      src/test-string-view.cc
-      src/test-filenames.cc
-      src/test-utf8.cc
-      src/test-wast-parser.cc
-      third_party/gtest/googletest/src/gtest_main.cc
-    )
-    wabt_executable(
-      NAME wabt-unittests
-      SOURCES ${UNITTESTS_SRCS}
-      LIBS libgtest ${CMAKE_THREAD_LIBS_INIT}
-    )
-
-    if (NOT CMAKE_VERSION VERSION_LESS "3.2")
-      set(USES_TERMINAL USES_TERMINAL)
-    endif ()
-
-    # test running
-    find_package(PythonInterp 2.7 REQUIRED)
+    if (NOT USE_SYSTEM_GTEST)
+      if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/third_party/gtest/googletest)
+        message(FATAL_ERROR "Can't find third_party/gtest. Run git submodule update --init, or disable with CMake -DBUILD_TESTS=OFF.")
+      endif ()
+
+      include_directories(
+        third_party/gtest/googletest
