=== debian/changelog ===
wabt (1.0.12-1) unstable; urgency=medium

  * New upstream version 1.0.12.
  * Build-depend on python3 instead of python. (Closes: #938805)

 -- Markus Koschany <apo@debian.org>  Sun, 29 Sep 2019 17:46:08 +0200
