=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends:
  cmake,
  debhelper-compat (= 12),
- python,
+ python3,
  re2c
 Standards-Version: 4.4.0
 Homepage: https://github.com/WebAssembly/wabt
