## wabt 1.0.13

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,8 @@
 cmake_minimum_required(VERSION 2.6)
 project(WABT)
 
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+
 option(BUILD_TESTS "Build GTest-based tests" ON)
 option(USE_SYSTEM_GTEST "Use system GTest, instead of building" OFF)
 option(BUILD_TOOLS "Build wabt commandline tools" ON)
@@ -27,9 +29,12 @@
 option(CODE_COVERAGE "Build with code coverage enabled" OFF)
 option(WITH_EXCEPTIONS "Build with exceptions enabled" OFF)
 option(WERROR "Build with warnings as errors" OFF)
-option(WIP_TOOLS "Build Work-In-Progress functionality" OFF)
-
-if (CMAKE_C_COMPILER_ID MATCHES "Clang")
+
+if (MSVC)
+  set(COMPILER_IS_CLANG 0)
+  set(COMPILER_IS_GNU 0)
+  set(COMPILER_IS_MSVC 1)
+elseif (CMAKE_C_COMPILER_ID MATCHES "Clang")
   set(COMPILER_IS_CLANG 1)
   set(COMPILER_IS_GNU 0)
   set(COMPILER_IS_MSVC 0)
@@ -37,10 +42,6 @@
   set(COMPILER_IS_CLANG 0)
   set(COMPILER_IS_GNU 1)
   set(COMPILER_IS_MSVC 0)
-elseif (MSVC)
-  set(COMPILER_IS_CLANG 0)
-  set(COMPILER_IS_GNU 0)
-  set(COMPILER_IS_MSVC 1)
 elseif (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
   set(COMPILER_IS_CLANG 1)
   set(COMPILER_IS_GNU 0)
@@ -68,6 +69,22 @@
 check_type_size(ssize_t SSIZE_T)
 check_type_size(size_t SIZEOF_SIZE_T)
 
+FIND_PACKAGE(Git QUIET REQUIRED)
+EXECUTE_PROCESS(COMMAND
+        "${GIT_EXECUTABLE}" --git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git describe --tags
+        RESULT_VARIABLE
+            GIT_HASH_RESULT
+        OUTPUT_VARIABLE
+            GIT_HASH
+        OUTPUT_STRIP_TRAILING_WHITESPACE)
+
+IF(${GIT_HASH_RESULT} EQUAL 0)
+    SET(WABT_VERSION_INFO "${GIT_HASH}")
+ELSE()
+    MESSAGE(WARNING "Error running git describe to determine version")
+    SET(WABT_VERSION_INFO "(unable to determine version)")
+ENDIF()
+
 configure_file(
   ${WABT_SOURCE_DIR}/src/config.h.in
   ${WABT_BINARY_DIR}/config.h
@@ -107,7 +124,7 @@
   endif ()
 
   if (NOT WITH_EXCEPTIONS)
-    add_definitions(-fno-exceptions)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")
   endif ()
 
   # Need to define __STDC_*_MACROS because C99 specifies that C++ shouldn't
@@ -171,7 +188,7 @@
 
 set(USE_SANITIZER FALSE)
 
-function(SANITIZER NAME FLAGS)
+function(sanitizer NAME FLAGS)
   if (${NAME})
     if (USE_SANITIZER)
       message(FATAL_ERROR "Only one sanitizer allowed")
@@ -181,22 +198,22 @@
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAGS}" PARENT_SCOPE)
   endif ()
 endfunction()
-SANITIZER(USE_ASAN "-fsanitize=address")
-SANITIZER(USE_MSAN "-fsanitize=memory")
-SANITIZER(USE_LSAN "-fsanitize=leak")
+sanitizer(USE_ASAN "-fsanitize=address")
+sanitizer(USE_MSAN "-fsanitize=memory")
+sanitizer(USE_LSAN "-fsanitize=leak")
 
 if (USE_UBSAN)
   # -fno-sanitize-recover was deprecated, see if we are compiling with a newer
   # clang that requires -fno-sanitize-recover=all.
   set(UBSAN_BLACKLIST ${WABT_SOURCE_DIR}/ubsan.blacklist)
   include(CheckCXXCompilerFlag)
-  CHECK_CXX_COMPILER_FLAG("-fsanitize=undefined -fno-sanitize-recover -Wall -Werror" HAS_UBSAN_RECOVER_BARE)
+  check_cxx_compiler_flag("-fsanitize=undefined -fno-sanitize-recover -Wall -Werror" HAS_UBSAN_RECOVER_BARE)
   if (HAS_UBSAN_RECOVER_BARE)
-    SANITIZER(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover -fsanitize-blacklist=${UBSAN_BLACKLIST}")
-  endif ()
-  CHECK_CXX_COMPILER_FLAG("-fsanitize=undefined -fno-sanitize-recover=all -Wall -Werror" HAS_UBSAN_RECOVER_ALL)
+    sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover -fsanitize-blacklist=${UBSAN_BLACKLIST}")
+  endif ()
+  check_cxx_compiler_flag("-fsanitize=undefined -fno-sanitize-recover=all -Wall -Werror" HAS_UBSAN_RECOVER_ALL)
   if (HAS_UBSAN_RECOVER_ALL)
-    SANITIZER(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover=all -fsanitize-blacklist=${UBSAN_BLACKLIST}")
+    sanitizer(USE_UBSAN "-fsanitize=undefined -fno-sanitize-recover=all -fsanitize-blacklist=${UBSAN_BLACKLIST}")
   endif ()
   if (NOT USE_SANITIZER)
     message(FATAL_ERROR "UBSAN is not supported")
@@ -207,7 +224,7 @@
 
 add_custom_target(everything)
 
-add_library(wabt STATIC
+set(WABT_LIBRARY_SRC
   src/apply-names.h
   src/apply-names.cc
   src/binary.h
@@ -231,6 +248,9 @@
   src/config.h
   src/config.cc
   src/decompiler.h
+  src/decompiler-ast.h
+  src/decompiler-ls.h
+  src/decompiler-naming.h
   src/decompiler.cc
   src/error-formatter.h
   src/error-formatter.cc
@@ -260,7 +280,6 @@
   src/opcode.cc
   src/opcode-code-table.h
   src/opcode-code-table.c
-  src/opcode.def
   src/option-parser.h
   src/option-parser.cc
   src/resolve-names.h
@@ -289,12 +308,27 @@
   # TODO(binji): Move this into its own library?
   src/interp/binary-reader-interp.h
   src/interp/binary-reader-interp.cc
+  src/interp/binary-reader-metadata.h
+  src/interp/binary-reader-metadata.cc
   src/interp/interp.h
   src/interp/interp.cc
   src/interp/interp-disassemble.cc
   src/interp/interp-trace.cc
 )
 
+add_library(wabt STATIC ${WABT_LIBRARY_SRC})
+
+# libwasm, which implenents the wasm C API
+add_library(wasm SHARED ${WABT_LIBRARY_SRC} src/interp/interp-wasm-c-api.cc)
+target_link_libraries(wasm wabt)
+target_include_directories(wasm PUBLIC third_party/wasm-c-api/include)
+if (COMPILER_IS_MSVC)
+  target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__declspec(dllexport)")
+else ()
+  target_compile_options(wasm PRIVATE -Wno-old-style-cast)
+  target_compile_definitions(wasm PRIVATE "WASM_API_EXTERN=__attribute__((visibility(\"default\")))")
+endif ()
+set_target_properties(wasm PROPERTIES CXX_VISIBILITY_PRESET hidden)
 
 if (NOT EMSCRIPTEN)
   if (CODE_COVERAGE)
@@ -374,63 +408,3 @@
     # wasm-objdump
     wabt_executable(
       NAME wasm-objdump
-      SOURCES src/tools/wasm-objdump.cc src/binary-reader-objdump.cc
-      INSTALL
-    )
-
-    # wasm-interp
-    wabt_executable(
-      NAME wasm-interp
-      SOURCES src/tools/wasm-interp.cc
-      WITH_LIBM
-      INSTALL
-    )
-
-    # spectest-interp
-    wabt_executable(
-      NAME spectest-interp
-      SOURCES src/tools/spectest-interp.cc
-      WITH_LIBM
-      INSTALL
-    )
-
-    # wat-desugar
-    wabt_executable(
-      NAME wat-desugar
-      SOURCES src/tools/wat-desugar.cc
-      INSTALL
-    )
-
-    # wasm-validate
-    wabt_executable(
-      NAME wasm-validate
-      SOURCES src/tools/wasm-validate.cc
-      INSTALL
-    )
-
-    # wasm-strip
-    wabt_executable(
-      NAME wasm-strip
-      SOURCES src/tools/wasm-strip.cc
-      INSTALL
-    )
-
-    if (WIP_TOOLS)
-      # wasm-decompile
-      wabt_executable(
-        NAME wasm-decompile
-        SOURCES src/tools/wasm-decompile.cc
-        INSTALL
-      )
-    endif()
-  endif ()
-
-  find_package(Threads)
-  if (BUILD_TESTS)
-    if (NOT USE_SYSTEM_GTEST)
-      if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/third_party/gtest/googletest)
-        message(FATAL_ERROR "Can't find third_party/gtest. Run git submodule update --init, or disable with CMake -DBUILD_TESTS=OFF.")
-      endif ()
-
-      include_directories(
-        third_party/gtest/googletest
