=== Makefile ===
--- 
+++ 
@@ -28,7 +28,7 @@
 
 DEFAULT_SUFFIX = clang-debug
 
-COMPILERS := GCC GCC_I686 GCC_FUZZ CLANG EMCC
+COMPILERS := GCC GCC_I686 GCC_FUZZ CLANG CLANG_I686 EMCC
 BUILD_TYPES := DEBUG RELEASE
 SANITIZERS := ASAN MSAN LSAN UBSAN
 CONFIGS := NORMAL $(SANITIZERS) COV NO_TESTS
@@ -38,6 +38,7 @@
 GCC_I686_DIR := gcc-i686/
 GCC_FUZZ_DIR := gcc-fuzz/
 CLANG_DIR := clang/
+CLANG_I686_DIR := clang-i686/
 EMCC_DIR := emscripten/
 DEBUG_DIR := Debug/
 RELEASE_DIR := Release/
@@ -55,6 +56,8 @@
 	-DCMAKE_C_FLAGS=-m32 -DCMAKE_CXX_FLAGS=-m32
 GCC_FUZZ_FLAG := -DCMAKE_C_COMPILER=${GCC_FUZZ_CC} -DCMAKE_CXX_COMPILER=${GCC_FUZZ_CXX} -DWITH_EXCEPTIONS=ON
 CLANG_FLAG := -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++
+CLANG_I686_FLAG := -DCMAKE_C_COMPILER=clang -DCMAKE_CXX_COMPILER=clang++ \
+	-DCMAKE_C_FLAGS=-m32 -DCMAKE_CXX_FLAGS=-m32
 EMCC_FLAG := -DCMAKE_TOOLCHAIN_FILE=${EMSCRIPTEN_DIR}/cmake/Modules/Platform/Emscripten.cmake
 DEBUG_FLAG := -DCMAKE_BUILD_TYPE=Debug
 RELEASE_FLAG := -DCMAKE_BUILD_TYPE=Release
@@ -71,6 +74,7 @@
 GCC_I686_PREFIX := gcc-i686
 GCC_FUZZ_PREFIX := gcc-fuzz
 CLANG_PREFIX := clang
+CLANG_I686_PREFIX := clang-i686
 EMCC_PREFIX := emscripten
 DEBUG_PREFIX := -debug
 RELEASE_PREFIX := -release
@@ -121,7 +125,7 @@
 define TEST
 .PHONY: $(call TEST_TARGET,$(1),$(2),$(3))
 $(call TEST_TARGET,$(1),$(2),$(3)): $(call CMAKE_DIR,$(1),$(2),$(3))$$(BUILD_FILE)
-	$$(BUILD_CMD) -C $(call CMAKE_DIR,$(1),$(2),$(3)) run-tests
+	$$(BUILD_CMD) -C $(call CMAKE_DIR,$(1),$(2),$(3)) check
 test-everything: $(CALL TEST_TARGET,$(1),$(2),$(3))
 endef
