=== debian/changelog ===
wabt (1.0.13-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:28:34 +0100

wabt (1.0.13-1) unstable; urgency=medium

  * New upstream version 1.0.13.
  * Declare compliance with Debian Policy 4.5.0.
  * Add two patches to not require Git for building wabt and to accommodate
    the missing wasm.h file.

 -- Markus Koschany <apo@debian.org>  Thu, 23 Jan 2020 22:58:51 +0100
