## wabt 1.0.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,10 +14,27 @@
 # limitations under the License.
 #
 
-cmake_minimum_required(VERSION 2.6)
-project(WABT)
+cmake_minimum_required(VERSION 3.0.0)
+project(WABT VERSION 1.0.13)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+
+# For git users, attempt to generate a more useful version string
+if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
+  find_package(Git QUIET REQUIRED)
+  execute_process(COMMAND
+          "${GIT_EXECUTABLE}" --git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git describe --tags
+          RESULT_VARIABLE
+              GIT_VERSION_RESULT
+          OUTPUT_VARIABLE
+              GIT_VERSION
+          OUTPUT_STRIP_TRAILING_WHITESPACE)
+  if (${GIT_VERSION_RESULT})
+    message(WARNING "Error running git describe to determine version")
+  else ()
+    set(CMAKE_PROJECT_VERSION "${CMAKE_PROJECT_VERSION} (${GIT_VERSION})")
+  endif ()
+endif ()
 
 option(BUILD_TESTS "Build GTest-based tests" ON)
 option(USE_SYSTEM_GTEST "Use system GTest, instead of building" OFF)
@@ -58,7 +75,6 @@
 check_include_file("alloca.h" HAVE_ALLOCA_H)
 check_include_file("unistd.h" HAVE_UNISTD_H)
 check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
-check_symbol_exists(sysconf "unistd.h" HAVE_SYSCONF)
 check_symbol_exists(strcasecmp "strings.h" HAVE_STRCASECMP)
 
 if (WIN32)
@@ -68,22 +84,6 @@
 include(CheckTypeSize)
 check_type_size(ssize_t SSIZE_T)
 check_type_size(size_t SIZEOF_SIZE_T)
-
-FIND_PACKAGE(Git QUIET REQUIRED)
-EXECUTE_PROCESS(COMMAND
-        "${GIT_EXECUTABLE}" --git-dir=${CMAKE_CURRENT_SOURCE_DIR}/.git describe --tags
-        RESULT_VARIABLE
-            GIT_HASH_RESULT
-        OUTPUT_VARIABLE
-            GIT_HASH
-        OUTPUT_STRIP_TRAILING_WHITESPACE)
-
-IF(${GIT_HASH_RESULT} EQUAL 0)
-    SET(WABT_VERSION_INFO "${GIT_HASH}")
-ELSE()
-    MESSAGE(WARNING "Error running git describe to determine version")
-    SET(WABT_VERSION_INFO "(unable to determine version)")
-ENDIF()
 
 configure_file(
   ${WABT_SOURCE_DIR}/src/config.h.in
@@ -117,6 +117,7 @@
     -Wuninitialized
   )
 
+  set(CMAKE_CXX_EXTENSIONS OFF)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wold-style-cast")
 
   if (WERROR)
@@ -132,11 +133,11 @@
   # definition, and some libcs (e.g. glibc2.17 and earlier) follow that.
   add_definitions(-D__STDC_LIMIT_MACROS=1 -D__STDC_FORMAT_MACROS=1)
 
-  if (MINGW)
-    # _POSIX is needed to ensure we use mingw printf
+  if (MINGW OR CYGWIN)
+    # On MINGW, _POSIX_C_SOURCE is needed to ensure we use mingw printf
     # instead of the VC runtime one.
-    add_definitions(-D_POSIX)
-  endif ()
+    add_definitions(-D_POSIX_C_SOURCE=200809L)
+  endif()
 
   if (COMPILER_IS_GNU)
     # disable -Wclobbered: it seems to be guessing incorrectly about a local
@@ -284,6 +285,8 @@
   src/option-parser.cc
   src/resolve-names.h
   src/resolve-names.cc
+  src/shared-validator.h
+  src/shared-validator.cc
   src/stream.h
   src/stream.cc
   src/string-view.h
@@ -292,6 +295,7 @@
   src/token.cc
   src/tracing.h
   src/tracing.cc
+  src/type.h
   src/type-checker.h
   src/type-checker.cc
   src/utf8.h
@@ -308,12 +312,14 @@
   # TODO(binji): Move this into its own library?
   src/interp/binary-reader-interp.h
   src/interp/binary-reader-interp.cc
-  src/interp/binary-reader-metadata.h
-  src/interp/binary-reader-metadata.cc
   src/interp/interp.h
   src/interp/interp.cc
-  src/interp/interp-disassemble.cc
-  src/interp/interp-trace.cc
+  src/interp/interp-inl.h
+  src/interp/interp-math.h
+  src/interp/interp-util.h
+  src/interp/interp-util.cc
+  src/interp/istream.h
+  src/interp/istream.cc
 )
 
 add_library(wabt STATIC ${WABT_LIBRARY_SRC})
@@ -340,6 +346,7 @@
     endif ()
   endif ()
 
+  include(CMakeParseArguments)
   function(wabt_executable)
     cmake_parse_arguments(EXE "WITH_LIBM;INSTALL" "NAME" "SOURCES;LIBS" ${ARGN})
 
@@ -396,15 +403,3 @@
       NAME wasm2c
       SOURCES src/tools/wasm2c.cc src/c-writer.cc
       INSTALL
-    )
-
-    # wasm-opcodecnt
-    wabt_executable(
-      NAME wasm-opcodecnt
-      SOURCES src/tools/wasm-opcodecnt.cc src/binary-reader-opcnt.cc
-      INSTALL
-    )
-
-    # wasm-objdump
-    wabt_executable(
-      NAME wasm-objdump
