=== debian/changelog ===
wabt (1.0.15-1) unstable; urgency=medium

  * New upstream version 1.0.15.
  * Switch to debhelper-compat = 13

 -- Markus Koschany <apo@debian.org>  Tue, 12 May 2020 00:41:09 +0200
